> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/sdn/location/describevirtualedgedatacenters.md).

# DescribeVirtualEdgeDatacenters

## 1. API Description

This API (DescribeVirtualEdgeDatacenters) is used to query Virtual Edge Gateway Data Centers

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description                                                                                                                         |
| -------------- | -------- | ------ | ----------------------------------------------------------------------------------------------------------------------------------- |
| primaryDcId    | No       | String | <p>Primary data center ID.</p><p>Used to filter available backup data centers when the access type is IPSec and HA is required.</p> |

## 3. Output Parameters

| Parameter Name | Type                                                                                  | Description                                                                                                           |
| -------------- | ------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                                | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| dcSet          | Array of [DataCenterAssemble](/api-reference/sdn/datastructure.md#datacenterassemble) | Result set.                                                                                                           |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Get the available Virtual Edge Gateway data center information.**

```
POST /api/v2/sdn HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeVirtualEdgeDatacenters
<Common Request Params>

Request: 
{
}

Response: 
{
  "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
  "response": {
    "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
    "dcSet": [
      {
        "dcId": "SIN1",
        "dcName": "AP-Singapore1",
        "cityName": "Singapore",
        "areaName": "Asia Pacific",
        "countryName": "Singapore",
        "latitude": 50.09708300,
        "longitude": 8.64414900,
        "dcAddress": "20 Ayer Rajah Crescent, Ayer Rajah Industrial Park, Singapore 139964",
        "availableBandwidth": 1000,
        "regionId": "SIN1",
        "isPortAvailable": true
      }
    ]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
